<CsoundSynthesizer>

<CsOptions>

</CsOptions>

<CsInstruments>
sr=44100
kr=441
ksmps=100
nchnls=2

ga1	init 	0
ga2	init	0
ga3	init 	0


; Include file needed for plain reverb, fluid
#include "rvb.h"


gi_scanned_initPos		ftgen 0, 0, 128, 7, 0, 128, 0		; initpos
gi_scanned_masses		ftgen 0, 0, 128, -7, 1, 128, 1		; masses
gi_scanned_centeringForce	ftgen 0, 0, 128, -7, 0, 128, 2		; centering force
gi_scanned_damping		ftgen 0, 0, 128, -7, 1, 128, 1		; damping
gi_scanned_initVelocity	ftgen 0, 0, 128, -7, -.0, 128, 0	; init velocity
gi_scanned_trajectory	ftgen 0, 0, 128, -7, 0, 128, 128	; trajectory

gi_scanned_matrix_string128		ftgen 0, 0, 16384, -23, "string-128"

gi_scanned_matrix_torus128		ftgen 0, 0, 16384, -23, "torus-128,8"

gi_scanned_matrix_circularString	ftgen 0, 0, 16384, -23, "circularstring-128"

gi_scanned_matrix_cylinder128		ftgen 0, 0, 16384, -23, "cylinder-128,8"

gi_scanned_matrix_steven2		ftgen 0, 0, 16384, -23, "steven2"



	instr 15	;feedback scanned - string128
ipch 	= p4
ipch2	= p5

ipch 	= (ipch < 15 ? cpspch(ipch) : ipch)
ipch2 	= (ipch2 < 15 ? cpspch(ipch2) : ipch2)

kpchline 	line ipch, p3, ipch2

iamp 	= ampdb(p6)
iSpace	= p7
ienvType	= p8

kenv 	init 	0

if ienvType == 0 kgoto env0  ; adsr
if ienvType == 1 kgoto env1  ; pyramid
if ienvType == 2 kgoto env2  ; ramp

env0:

	kenv	adsr	.3, .2, .9, .5

	kgoto endEnvelope

env1:
	
	kenv 	linseg	0, p3 * .5, 1, p3 * .5, 0

	kgoto endEnvelope

env2:
	
	kenv	linseg 	0, p3 - .1, 1, .1, 0	

	kgoto endEnvelope

endEnvelope:


;iforce	= p5 * .0004
;iforce = iamp * .0004
iforce = (iamp / 0dbfs) * .5

;ain	linseg 0, p3 * .5, iforce, p3 *.5, 0

ain 	init 0

aforce	= kenv * iforce 

ain	= ain + aforce



ifnmatrix	 = gi_scanned_matrix_string128


iscantable	 = gi_scanned_trajectory

; PARAMETERS FOR SCANU
iInit	= gi_scanned_initPos
irate	= .02

ifnvel	= gi_scanned_initVelocity
ifnmass	= gi_scanned_masses
ifncenter	= gi_scanned_centeringForce
ifndamp	= gi_scanned_damping

kmass	= 2
kstiff	= .05
kcenter	= .1
kdamp 	= -.4

ileft	= .1
iright	= .3
kpos	= .2
kstrength	= 0

idisp	= 0
id	= 2


	scanu	iInit,irate,ifnvel,ifnmass,ifnmatrix,ifncenter,ifndamp,kmass,kstiff,kcenter,kdamp,ileft,iright,kpos,kstrength,ain,idisp,id

aout	scans	1, kpchline, iscantable, id

ain	= aout * .0002

aout 	dcblock aout

aout	butterlp	aout, kpchline * 8 * kenv
aout	butterlp	aout, kpchline * 8 * kenv

aout	nreverb	aout, 1, .2

;aout	= aout * kenv * iamp
aout	= aout * iamp * .9

iSpace	= iSpace * 3.14159265359 * .5
krtl     	= sqrt(2) / 2 * (cos(iSpace) + sin(iSpace)) ; CONSTANT POWER PANNING
krtr     	= sqrt(2) / 2 * (cos(iSpace) - sin(iSpace)) ; FROM C.ROADS "CM TUTORIAL" pp460

aLeft 	=	aout * krtl
aRight	=	aout * krtr

;	outs aLeft, aRight

ga1 = ga1 + aLeft
ga2 = ga2 + aRight 

	endin

	instr 16	;feedback scanned - torus128
ipch 	= p4
ipch2	= p5

ipch 	= (ipch < 15 ? cpspch(ipch) : ipch)
ipch2 	= (ipch2 < 15 ? cpspch(ipch2) : ipch2)

kpchline 	line ipch, p3, ipch2

iamp 	= ampdb(p6)
iSpace	= p7
ienvType	= p8

kenv 	init 	0

if ienvType == 0 kgoto env0  ; adsr
if ienvType == 1 kgoto env1  ; pyramid
if ienvType == 2 kgoto env2  ; ramp

env0:

	kenv	adsr	.3, .2, .9, .5

	kgoto endEnvelope

env1:
	
	kenv 	linseg	0, p3 * .5, 1, p3 * .5, 0

	kgoto endEnvelope

env2:
	
	kenv	linseg 	0, p3 - .1, 1, .1, 0	

	kgoto endEnvelope

endEnvelope:


;iforce	= p5 * .0004
;iforce = iamp * .0004
iforce = (iamp / 0dbfs) * .5

;ain	linseg 0, p3 * .5, iforce, p3 *.5, 0

ain 	init 0

aforce	= kenv * iforce 

ain	= ain + aforce



ifnmatrix	 = gi_scanned_matrix_torus128
;ifnmatrix	 = gi_scanned_matrix_string128 

iscantable	 = gi_scanned_trajectory

; PARAMETERS FOR SCANU
iInit	= gi_scanned_initPos
irate	= .02

ifnvel	= gi_scanned_initVelocity
ifnmass	= gi_scanned_masses
ifncenter	= gi_scanned_centeringForce
ifndamp	= gi_scanned_damping

kmass	= 2
kstiff	= .05
kcenter	= .1
kdamp 	= -.4

ileft	= .1
iright	= .3
kpos	= .2
kstrength	= 0

idisp	= 0
id	= 2


	scanu	iInit,irate,ifnvel,ifnmass,ifnmatrix,ifncenter,ifndamp,kmass,kstiff,kcenter,kdamp,ileft,iright,kpos,kstrength,ain,idisp,id

aout	scans	1, kpchline, iscantable, id

ain	= aout * .0002

aout 	dcblock aout

aout	butterlp	aout, kpchline * 8 * kenv
aout	butterlp	aout, kpchline * 8 * kenv

aout	nreverb	aout, 1, .2

;aout	= aout * kenv * iamp
aout	= aout * iamp * .9

iSpace	= iSpace * 3.14159265359 * .5
krtl     	= sqrt(2) / 2 * (cos(iSpace) + sin(iSpace)) ; CONSTANT POWER PANNING
krtr     	= sqrt(2) / 2 * (cos(iSpace) - sin(iSpace)) ; FROM C.ROADS "CM TUTORIAL" pp460

aLeft 	=	aout * krtl
aRight	=	aout * krtr

;	outs aLeft, aRight

ga1 = ga1 + aLeft
ga2 = ga2 + aRight 

	endin

	instr 17	;feedback scanned - circularstring128
ipch 	= p4
ipch2	= p5

ipch 	= (ipch < 15 ? cpspch(ipch) : ipch)
ipch2 	= (ipch2 < 15 ? cpspch(ipch2) : ipch2)

kpchline 	line ipch, p3, ipch2

iamp 	= ampdb(p6)
iSpace	= p7
ienvType	= p8

kenv 	init 	0

if ienvType == 0 kgoto env0  ; adsr
if ienvType == 1 kgoto env1  ; pyramid
if ienvType == 2 kgoto env2  ; ramp

env0:

	kenv	adsr	.3, .2, .9, .5

	kgoto endEnvelope

env1:
	
	kenv 	linseg	0, p3 * .5, 1, p3 * .5, 0

	kgoto endEnvelope

env2:
	
	kenv	linseg 	0, p3 - .1, 1, .1, 0	

	kgoto endEnvelope

endEnvelope:


;iforce	= p5 * .0004
;iforce = iamp * .0004
iforce = (iamp / 0dbfs) * .5

;ain	linseg 0, p3 * .5, iforce, p3 *.5, 0

ain 	init 0

aforce	= kenv * iforce 

ain	= ain + aforce



ifnmatrix	 = gi_scanned_matrix_circularString
;ifnmatrix	 = gi_scanned_matrix_string128 

iscantable	 = gi_scanned_trajectory

; PARAMETERS FOR SCANU
iInit	= gi_scanned_initPos
irate	= .02

ifnvel	= gi_scanned_initVelocity
ifnmass	= gi_scanned_masses
ifncenter	= gi_scanned_centeringForce
ifndamp	= gi_scanned_damping

kmass	= 2
kstiff	= .05
kcenter	= .1
kdamp 	= -.4

ileft	= .1
iright	= .3
kpos	= .2
kstrength	= 0

idisp	= 0
id	= 2


	scanu	iInit,irate,ifnvel,ifnmass,ifnmatrix,ifncenter,ifndamp,kmass,kstiff,kcenter,kdamp,ileft,iright,kpos,kstrength,ain,idisp,id

aout	scans	1, kpchline, iscantable, id

ain	= aout * .0002

aout 	dcblock aout

aout	butterlp	aout, kpchline * 8 * kenv
aout	butterlp	aout, kpchline * 8 * kenv

aout	nreverb	aout, 1, .2

;aout	= aout * kenv * iamp
aout	= aout * iamp * .9

iSpace	= iSpace * 3.14159265359 * .5
krtl     	= sqrt(2) / 2 * (cos(iSpace) + sin(iSpace)) ; CONSTANT POWER PANNING
krtr     	= sqrt(2) / 2 * (cos(iSpace) - sin(iSpace)) ; FROM C.ROADS "CM TUTORIAL" pp460

aLeft 	=	aout * krtl
aRight	=	aout * krtr

;	outs aLeft, aRight

ga1 = ga1 + aLeft
ga2 = ga2 + aRight 

	endin

	instr 18	;design1 - cylinder128
ipch 	= p4
ipch2	= p5

ipch 	= (ipch < 15 ? cpspch(ipch) : ipch)
ipch2 	= (ipch2 < 15 ? cpspch(ipch2) : ipch2)

kpchline 	line ipch, p3, ipch2

iamp 	= ampdb(p6)
iSpace	= p7
ienvType	= p8

kenv 	init 	0

if ienvType == 0 kgoto env0  ; adsr
if ienvType == 1 kgoto env1  ; pyramid
if ienvType == 2 kgoto env2  ; ramp

env0:

	kenv	adsr	.3, .2, .9, .5

	kgoto endEnvelope

env1:
	
	kenv 	linseg	0, p3 * .5, 1, p3 * .5, 0

	kgoto endEnvelope

env2:
	
	kenv	linseg 	0, p3 - .1, 1, .1, 0	

	kgoto endEnvelope

endEnvelope:


;iforce	= p5 * .0004
;iforce = iamp * .0004
iforce = iamp / 0dbfs

;ain	linseg 0, p3 * .5, iforce, p3 *.5, 0

ain	= kenv * iforce


ifnmatrix	 = gi_scanned_matrix_cylinder128 

iscantable	 = gi_scanned_trajectory

; PARAMETERS FOR SCANU
iInit	= gi_scanned_initPos
irate	= .02

ifnvel	= gi_scanned_initVelocity
ifnmass	= gi_scanned_masses
ifncenter	= gi_scanned_centeringForce
ifndamp	= gi_scanned_damping

kmass	= 2
kstiff	= .05
kcenter	= .1
kdamp 	= -.4

ileft	= .1
iright	= .3
kpos	= .2
kstrength	= 0

idisp	= 0
id	= 2


	scanu	iInit,irate,ifnvel,ifnmass,ifnmatrix,ifncenter,ifndamp,kmass,kstiff,kcenter,kdamp,ileft,iright,kpos,kstrength,ain,idisp,id

aout	scans	1, kpchline, iscantable, id

aout 	dcblock aout

aout	butterlp	aout, (kpchline * 6 * kenv) + kpchline 
aout	butterlp	aout, (kpchline * 6 * kenv) + kpchline 

aout	nreverb	aout, .1, .2

;aout	= aout * kenv * iamp
aout	= aout * iamp * .9

iSpace	= iSpace * 3.14159265359 * .5
krtl     	= sqrt(2) / 2 * (cos(iSpace) + sin(iSpace)) ; CONSTANT POWER PANNING
krtr     	= sqrt(2) / 2 * (cos(iSpace) - sin(iSpace)) ; FROM C.ROADS "CM TUTORIAL" pp460

aLeft 	=	aout * krtl
aRight	=	aout * krtr

;	outs aLeft, aRight

ga1 = ga1 + aLeft
ga2 = ga2 + aRight 

	endin

	instr 19	;double scanned - steven2
ipch 	= p4
ipch2	= p5

ipch 	= (ipch < 15 ? cpspch(ipch) : ipch)
ipch2 	= (ipch2 < 15 ? cpspch(ipch2) : ipch2)

kpchline 	line ipch, p3, ipch2

iamp 	= ampdb(p6)
iSpace	= p7
ienvType	= p8

kenv 	init 	0

if ienvType == 0 kgoto env0  ; adsr
if ienvType == 1 kgoto env1  ; pyramid
if ienvType == 2 kgoto env2  ; ramp

env0:

	kenv	adsr	.3, .2, .9, .5

	kgoto endEnvelope

env1:
	
	kenv 	linseg	0, p3 * .5, 1, p3 * .5, 0

	kgoto endEnvelope

env2:
	
	kenv	linseg 	0, p3 - .1, 1, .1, 0	

	kgoto endEnvelope

endEnvelope:


;iforce	= p5 * .0004
;iforce = iamp * .0004
iforce = iamp / 0dbfs

;ain	linseg 0, p3 * .5, iforce, p3 *.5, 0


ain 	init 0

aforce	= kenv * iforce

ain	= aforce - ain

ifnmatrix	 = gi_scanned_matrix_steven2

iscantable	 = gi_scanned_trajectory

; PARAMETERS FOR SCANU
iInit	= gi_scanned_initPos
irate	= .02

ifnvel	= gi_scanned_initVelocity
ifnmass	= gi_scanned_masses
ifncenter	= gi_scanned_centeringForce
ifndamp	= gi_scanned_damping

kmass	= 2
kstiff	= .05
kcenter	= .1
kdamp 	= -.4

ileft	= .1
iright	= .3
kpos	= .2
kstrength	= 0
;kstrength	line 0, p3, .001

idisp	= 0
id	= 2
id2 = 3


	scanu	iInit,irate,ifnvel,ifnmass,ifnmatrix,ifncenter,ifndamp,kmass,kstiff,kcenter,kdamp,ileft,iright,kpos,kstrength,ain,idisp,id

	scanu iInit,irate,ifnvel,ifnmass,ifnmatrix,ifncenter,ifndamp,1,.04,kcenter,kdamp,ileft,iright,kpos,kstrength,aforce,idisp,id2

aout	scans	1, kpchline, iscantable, 2
aout2	scans	1, kpchline, iscantable, id2

ain	= aout2 * .02
aout 	dcblock aout

aout	butterlp	aout, kpchline * 8 * kenv
aout	butterlp	aout, kpchline * 8 * kenv

aout	nreverb	aout, 1, .2



;aout	= aout * kenv * iamp
aout	= aout * iamp * .9

iSpace	= iSpace * 3.14159265359 * .5
krtl     	= sqrt(2) / 2 * (cos(iSpace) + sin(iSpace)) ; CONSTANT POWER PANNING
krtr     	= sqrt(2) / 2 * (cos(iSpace) - sin(iSpace)) ; FROM C.ROADS "CM TUTORIAL" pp460

aLeft 	=	aout * krtl
aRight	=	aout * krtr

;	outs aLeft, aRight

ga1 = ga1 + aLeft
ga2 = ga2 + aRight 

	endin

	instr 20	;Guitar
ipch 	= p4
ipch2	= p5

ipch 	= (ipch < 15 ? cpspch(ipch) : ipch)
ipch2 	= (ipch2 < 15 ? cpspch(ipch2) : ipch2)

kpchline 	line ipch, p3, ipch2

iamp 		= ampdb(p6)
iSpace		= p7
iArticulation	= p8

kenv 	init 	0

iCPS	= (ipch < ipch2 ? ipch : ipch2)

if (iArticulation == 0) then 

	kamp      linseg    0.0, 0.015, iamp * 2, p3-0.065, iamp *2, 0.05, 0.0
;	asig      pluck     kamp, p5, p5, 0, 1                
	asig      pluck     kamp, kpchline, iCPS, 0, 1                
	af1       reson     asig, 110, 80
	af2       reson     asig, 220, 100
	af3       reson     asig, 440, 80
	aout      balance   0.6*af1+af2+0.6*af3+0.4*asig, asig

elseif (iArticulation == 1) then  ; HAMMER/PULL

	kamp      linseg    0.0, 0.015, iamp *2, p3-0.065, iamp *2, 0.05, 0.0
	kfreq     linseg    p5, p7*p3, p5, 0.005, p6, (1-p7)*p3-0.005, p6
	asig      pluck     kamp, kfreq, p5, 0, 1
	af1       reson     asig, 110, 80
	af2       reson     asig, 220, 100
	af3       reson     asig, 440, 80
	aout      balance   0.6*af1+af2+0.6*af3+0.4*asig, asig


elseif (iArticulation == 2) then ; HARMONIC

	kamp      linseg    0.0, 0.015, iamp * 2, p3-0.035, iamp *2, 0.02, 0.0
	aout      pluck     kamp, p5, p5, 0, 6	
	
endif


iSpace	= iSpace * 3.14159265359 * .5
krtl     	= sqrt(2) / 2 * (cos(iSpace) + sin(iSpace)) ; CONSTANT POWER PANNING
krtr     	= sqrt(2) / 2 * (cos(iSpace) - sin(iSpace)) ; FROM C.ROADS "CM TUTORIAL" pp460

aLeft 	=	aout * krtl
aRight	=	aout * krtr

;	outs aLeft, aRight

ga1 = ga1 + aLeft
ga2 = ga2 + aRight 

	endin

	instr 1000	;plain reverb
$xrvb2s(ga3'aoutL'aoutR'.2'1'1000)
	
ga1 = ga1 + aoutL
ga2 = ga2 + aoutL

ga3 = 0
	endin

	instr 1001	;Pass Through
outs	ga1, ga2
outs	ga3, ga3

ga1 = 0
ga2 = 0
ga3 = 0
	endin


</CsInstruments>

<CsScore>










i1000 0.0 [13.5625 + 10 - 0.0] 
i1001 0 [13.5625 + 1]


i20	0.0	0.8020833	8.0	8.0	80	0	0	
i20	0.8020833	1.6041666	8.03	8.03	80	0	0	
i20	2.40625	0.8020833	8.07	8.07	80	0	0	
i20	3.2083333	0.8020833	8.08	8.08	80	0	0	
i20	4.0104165	0.8020833	8.1	8.1	80	0	0	
i20	4.8125	2.40625	9.0	9.0	80	0	0	
i20	2.0	1.0243056	8.0	8.0	80	0	0	
i20	3.0243056	2.0486112	8.03	8.03	80	0	0	
i20	5.072917	1.0243056	8.07	8.07	80	0	0	
i20	6.0972223	1.0243056	8.08	8.08	80	0	0	
i20	7.1215277	1.0243056	8.1	8.1	80	0	0	
i20	8.145834	3.0729167	9.0	9.0	80	0	0	
i20	4.515625	1.0052084	8.0	8.0	80	0	0	
i20	5.5208335	2.0104167	8.03	8.03	80	0	0	
i20	7.53125	1.0052084	8.07	8.07	80	0	0	
i20	8.536459	1.0052084	8.08	8.08	80	0	0	
i20	9.541667	1.0052084	8.1	8.1	80	0	0	
i20	10.546875	3.015625	9.0	9.0	80	0	0	
i20	1.46875	1.0243056	7.07	7.07	60	0	0	
i20	2.4930556	2.0486112	7.1	7.1	60	0	0	
i20	4.541667	1.0243056	8.02	8.02	60	0	0	
i20	5.5659723	1.0243056	8.03	8.03	60	0	0	
i20	6.5902777	1.0243056	8.05	8.05	60	0	0	
i20	7.6145835	3.0729167	8.07	8.07	60	0	0	
e

</CsScore>

</CsoundSynthesizer>